import './packages/shared/build/esm/node_modules/.pnpm/chalk@5.2.0/node_modules/chalk/source/index.mjs';
import 'readline';
import './packages/shared/build/esm/loading.mjs';
import './packages/shared/build/esm/node_modules/.pnpm/semver@7.5.1/node_modules/semver/index.mjs';
import require$$1 from 'path';
import './packages/shared/build/esm/node_modules/.pnpm/fs-extra@11.1.1/node_modules/fs-extra/lib/index.mjs';
import 'node:fs';
import 'node:fs/promises';
import 'node:path';
import 'node:url';
import './packages/shared/build/esm/node_modules/.pnpm/parse-json@7.0.0_typescript@5.0.4/node_modules/parse-json/index.mjs';
import './packages/shared/build/esm/node_modules/.pnpm/normalize-package-data@5.0.0/node_modules/normalize-package-data/lib/normalize.mjs';
import 'child_process';
import { isPureObject, isString } from './packages/shared/build/esm/data-type-judgment.mjs';
import './packages/shared/build/esm/node_modules/.pnpm/esbuild@0.17.18/node_modules/esbuild/lib/main.mjs';
import 'module';
import { DefinePlugin } from 'webpack';
import WebpackBarPlugin from 'webpackbar';

function baseConfig(api) {
  api.injectWebpackConfig((config) => {
    config.bail(false).context(api.cwd).end();
    config.mode(api.mode === "development" ? "development" : "production").end();
    config.entry("app").add(api.adcConfig.entry || "src/index.ts").end();
    config.output.path(api.resolve(api.adcConfig.outputDir || "dist")).publicPath(api.adcConfig.publicPath || "/").filename("js/[name].[contenthash:8].js").chunkFilename("js/[name].[contenthash:8].js").hashFunction("xxhash64").end();
    config.resolve.modules.add("node_modules").add(api.resolve("node_modules")).add(require$$1.resolve(__dirname, "../../node_modules")).end();
    config.resolve.extensions.merge([".js", ".cjs", ".mjs", ".jsx", ".ts", ".tsx", ".json"]).end();
    config.resolve.alias.set("@", api.resolve("src")).end();
    if (isPureObject(api.adcConfig.alias)) {
      Object.entries(api.adcConfig.alias).forEach(([k, v]) => {
        config.resolve.alias.set(k, v).end();
      });
    }
    if (api.adcConfig.externals) {
      config.externals(api.adcConfig.externals);
    }
    config.devtool(
      isString(api.adcConfig.sourceMap) ? api.adcConfig.sourceMap : api.mode === "production" ? "source-map" : false
    ).end();
    config.plugin("WebpackBarPlugin").use(WebpackBarPlugin, [
      {
        color: "#0075FF"
      }
    ]).end();
    config.plugin("DefinePlugin").use(DefinePlugin, [
      {
        NODE_ENV: JSON.stringify(api.mode),
        PUBLIC_PATH: JSON.stringify(api.adcConfig?.publicPath || "/")
      }
    ]);
  });
}

export { baseConfig as default };
