import MiniCssExtractPlugin from 'mini-css-extract-plugin';

function cssConfig(api) {
  api.injectWebpackConfig((config) => {
    const styleLoader = api.mode === "development" ? require.resolve("style-loader") : MiniCssExtractPlugin.loader;
    const postcssOptions = {
      ...api.adcConfig.postcss?.options || {},
      plugins: [
        "autoprefixer",
        ...api.adcConfig.postcss?.options?.plugins || []
      ]
    };
    config.module.rule("\u7F16\u8BD1 CSS").test(/\.css$/).exclude.add(/\.module\.css$/).end().use("style-loader").loader(styleLoader).end().use("css-loader").loader(require.resolve("css-loader")).options({
      modules: false
    }).end().use("postcss-loader").loader(require.resolve("postcss-loader")).options({
      postcssOptions
    }).end();
    config.module.rule("\u7F16\u8BD1\u6A21\u5757\u4F5C\u7528\u57DF CSS").test(/\.module\.css$/).use("style-loader").loader(styleLoader).end().use("css-loader").loader(require.resolve("css-loader")).options({
      modules: {
        localIdentName: "[name]_[local]_[hash:base64:5]"
      }
    }).end().use("postcss-loader").loader(require.resolve("postcss-loader")).options({
      postcssOptions
    }).end();
    config.module.rule("\u7F16\u8BD1 less").test(/\.less$/).exclude.add(/\.module\.less$/).end().use("style-loader").loader(styleLoader).end().use("css-loader").loader(require.resolve("css-loader")).options({
      modules: false
    }).end().use("postcss-loader").loader(require.resolve("postcss-loader")).options({
      postcssOptions
    }).end().use("less-loader").loader(require.resolve("less-loader")).options({
      lessOptions: {}
    }).end();
    config.module.rule("\u7F16\u8BD1\u6A21\u5757\u4F5C\u7528\u57DF less").test(/\.module\.less$/).use("style-loader").loader(styleLoader).end().use("css-loader").loader(require.resolve("css-loader")).options({
      modules: {
        localIdentName: "[name]_[local]_[hash:base64:5]"
      }
    }).end().use("postcss-loader").loader(require.resolve("postcss-loader")).options({
      postcssOptions
    }).end().use("less-loader").loader(require.resolve("less-loader")).options({
      lessOptions: {}
    }).end();
    if (api.mode === "production") {
      config.plugin("MiniCssExtractPlugin").use(MiniCssExtractPlugin, [
        {
          filename: "css/[name].[contenthash].css",
          chunkFilename: "css/[name].[contenthash].css"
        }
      ]).end();
    }
  });
}

export { cssConfig as default };
