import '../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.mjs';
import require$$1 from 'path';
import { g as gracefulFs } from '../../../../../graceful-fs@4.2.11/node_modules/graceful-fs/graceful-fs.mjs';
import { m as mkdirs } from '../mkdirs/index.mjs';
import { __exports as universalify } from '../../../../../../../_virtual/index2.mjs';

const u = universalify.fromCallback;
const path = require$$1;
const fs = gracefulFs;
const mkdir = mkdirs;

function createFile (file, callback) {
  function makeFile () {
    fs.writeFile(file, '', err => {
      if (err) return callback(err)
      callback();
    });
  }

  fs.stat(file, (err, stats) => { // eslint-disable-line handle-callback-err
    if (!err && stats.isFile()) return callback()
    const dir = path.dirname(file);
    fs.stat(dir, (err, stats) => {
      if (err) {
        // if the directory doesn't exist, make it
        if (err.code === 'ENOENT') {
          return mkdir.mkdirs(dir, err => {
            if (err) return callback(err)
            makeFile();
          })
        }
        return callback(err)
      }

      if (stats.isDirectory()) makeFile();
      else {
        // parent is not a directory
        // This is just to cause an internal ENOTDIR error to be thrown
        fs.readdir(dir, err => {
          if (err) return callback(err)
        });
      }
    });
  });
}

function createFileSync (file) {
  let stats;
  try {
    stats = fs.statSync(file);
  } catch {}
  if (stats && stats.isFile()) return

  const dir = path.dirname(file);
  try {
    if (!fs.statSync(dir).isDirectory()) {
      // parent is not a directory
      // This is just to cause an internal ENOTDIR error to be thrown
      fs.readdirSync(dir);
    }
  } catch (err) {
    // If the stat call above failed because the directory doesn't exist, create it
    if (err && err.code === 'ENOENT') mkdir.mkdirsSync(dir);
    else throw err
  }

  fs.writeFileSync(file, '');
}

var file = {
  createFile: u(createFile),
  createFileSync
};

export { file as f };
