import '../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.mjs';
import require$$1 from 'path';
import { g as gracefulFs } from '../../../../../graceful-fs@4.2.11/node_modules/graceful-fs/graceful-fs.mjs';
import { m as mkdirs } from '../mkdirs/index.mjs';
import { p as pathExists_1 } from '../path-exists/index.mjs';
import { s as stat } from '../util/stat.mjs';
import { __exports as universalify } from '../../../../../../../_virtual/index2.mjs';

const u = universalify.fromCallback;
const path = require$$1;
const fs = gracefulFs;
const mkdir = mkdirs;
const pathExists = pathExists_1.pathExists;
const { areIdentical } = stat;

function createLink (srcpath, dstpath, callback) {
  function makeLink (srcpath, dstpath) {
    fs.link(srcpath, dstpath, err => {
      if (err) return callback(err)
      callback(null);
    });
  }

  fs.lstat(dstpath, (_, dstStat) => {
    fs.lstat(srcpath, (err, srcStat) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureLink');
        return callback(err)
      }
      if (dstStat && areIdentical(srcStat, dstStat)) return callback(null)

      const dir = path.dirname(dstpath);
      pathExists(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return makeLink(srcpath, dstpath)
        mkdir.mkdirs(dir, err => {
          if (err) return callback(err)
          makeLink(srcpath, dstpath);
        });
      });
    });
  });
}

function createLinkSync (srcpath, dstpath) {
  let dstStat;
  try {
    dstStat = fs.lstatSync(dstpath);
  } catch {}

  try {
    const srcStat = fs.lstatSync(srcpath);
    if (dstStat && areIdentical(srcStat, dstStat)) return
  } catch (err) {
    err.message = err.message.replace('lstat', 'ensureLink');
    throw err
  }

  const dir = path.dirname(dstpath);
  const dirExists = fs.existsSync(dir);
  if (dirExists) return fs.linkSync(srcpath, dstpath)
  mkdir.mkdirsSync(dir);

  return fs.linkSync(srcpath, dstpath)
}

var link = {
  createLink: u(createLink),
  createLinkSync
};

export { link as l };
