import '../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.mjs';
import require$$1 from 'path';
import '../fs/index.mjs';
import { m as mkdirs$1 } from '../mkdirs/index.mjs';
import { s as symlinkPaths_1 } from './symlink-paths.mjs';
import { s as symlinkType_1 } from './symlink-type.mjs';
import { p as pathExists_1 } from '../path-exists/index.mjs';
import { s as stat } from '../util/stat.mjs';
import { __exports as universalify } from '../../../../../../../_virtual/index2.mjs';
import { __exports as fs$1 } from '../../../../../../../_virtual/index.mjs';

const u = universalify.fromCallback;
const path = require$$1;
const fs = fs$1;
const _mkdirs = mkdirs$1;
const mkdirs = _mkdirs.mkdirs;
const mkdirsSync = _mkdirs.mkdirsSync;

const _symlinkPaths = symlinkPaths_1;
const symlinkPaths = _symlinkPaths.symlinkPaths;
const symlinkPathsSync = _symlinkPaths.symlinkPathsSync;

const _symlinkType = symlinkType_1;
const symlinkType = _symlinkType.symlinkType;
const symlinkTypeSync = _symlinkType.symlinkTypeSync;

const pathExists = pathExists_1.pathExists;

const { areIdentical } = stat;

function createSymlink (srcpath, dstpath, type, callback) {
  callback = (typeof type === 'function') ? type : callback;
  type = (typeof type === 'function') ? false : type;

  fs.lstat(dstpath, (err, stats) => {
    if (!err && stats.isSymbolicLink()) {
      Promise.all([
        fs.stat(srcpath),
        fs.stat(dstpath)
      ]).then(([srcStat, dstStat]) => {
        if (areIdentical(srcStat, dstStat)) return callback(null)
        _createSymlink(srcpath, dstpath, type, callback);
      });
    } else _createSymlink(srcpath, dstpath, type, callback);
  });
}

function _createSymlink (srcpath, dstpath, type, callback) {
  symlinkPaths(srcpath, dstpath, (err, relative) => {
    if (err) return callback(err)
    srcpath = relative.toDst;
    symlinkType(relative.toCwd, type, (err, type) => {
      if (err) return callback(err)
      const dir = path.dirname(dstpath);
      pathExists(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return fs.symlink(srcpath, dstpath, type, callback)
        mkdirs(dir, err => {
          if (err) return callback(err)
          fs.symlink(srcpath, dstpath, type, callback);
        });
      });
    });
  });
}

function createSymlinkSync (srcpath, dstpath, type) {
  let stats;
  try {
    stats = fs.lstatSync(dstpath);
  } catch {}
  if (stats && stats.isSymbolicLink()) {
    const srcStat = fs.statSync(srcpath);
    const dstStat = fs.statSync(dstpath);
    if (areIdentical(srcStat, dstStat)) return
  }

  const relative = symlinkPathsSync(srcpath, dstpath);
  srcpath = relative.toDst;
  type = symlinkTypeSync(relative.toCwd, type);
  const dir = path.dirname(dstpath);
  const exists = fs.existsSync(dir);
  if (exists) return fs.symlinkSync(srcpath, dstpath, type)
  mkdirsSync(dir);
  return fs.symlinkSync(srcpath, dstpath, type)
}

var symlink = {
  createSymlink: u(createSymlink),
  createSymlinkSync
};

export { symlink as s };
