import '../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.mjs';
import { g as gracefulFs } from '../../../../../graceful-fs@4.2.11/node_modules/graceful-fs/graceful-fs.mjs';
import require$$1 from 'path';
import { m as mkdirs } from '../mkdirs/index.mjs';
import { p as pathExists_1 } from '../path-exists/index.mjs';
import { __exports as universalify } from '../../../../../../../_virtual/index2.mjs';

const u = universalify.fromCallback;
const fs = gracefulFs;
const path = require$$1;
const mkdir = mkdirs;
const pathExists = pathExists_1.pathExists;

function outputFile (file, data, encoding, callback) {
  if (typeof encoding === 'function') {
    callback = encoding;
    encoding = 'utf8';
  }

  const dir = path.dirname(file);
  pathExists(dir, (err, itDoes) => {
    if (err) return callback(err)
    if (itDoes) return fs.writeFile(file, data, encoding, callback)

    mkdir.mkdirs(dir, err => {
      if (err) return callback(err)

      fs.writeFile(file, data, encoding, callback);
    });
  });
}

function outputFileSync (file, ...args) {
  const dir = path.dirname(file);
  if (fs.existsSync(dir)) {
    return fs.writeFileSync(file, ...args)
  }
  mkdir.mkdirsSync(dir);
  fs.writeFileSync(file, ...args);
}

var outputFile_1 = {
  outputFile: u(outputFile),
  outputFileSync
};

export { outputFile_1 as o };
