'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function babelConfig(api) {
  const dev = api.mode === "development";
  api.injectWebpackConfig((config) => {
    config.module.rule("\u7F16\u8BD1 \u811A\u672C").test(/\.(js|jsx|ts|tsx|cjs|mjs)$/).exclude.add(/node_modules/).end().use(
      "\u4F7F\u7528 thread-loader \u8FD0\u884C\u4EE5\u4E0B loader \u5728 worker pool \u4E2D https://webpack.docschina.org/loaders/thread-loader/#root"
    ).loader(require.resolve("thread-loader")).end().use("\u4F7F\u7528 babel \u505A\u4E3A\u8F6C\u8BD1\u5668 https://www.npmjs.com/package/babel-loader").loader(require.resolve("babel-loader")).options({
      presets: [
        [
          require.resolve("@babel/preset-env"),
          {
            targets: {
              browsers: api.pkgJson?.browserslist || [
                ">1%",
                "last 2 versions",
                "not dead"
              ]
            }
          }
        ],
        require.resolve("@babel/preset-react"),
        require.resolve("@babel/preset-typescript")
      ],
      plugins: [
        // https://babeljs.io/docs/babel-plugin-transform-runtime
        [require.resolve("@babel/plugin-transform-runtime"), { corejs: 3 }],
        // 用于 react 热重载 开发环境特有：https://github.com/pmmmwh/react-refresh-webpack-plugin
        dev ? require.resolve("react-refresh/babel") : null
      ].filter(Boolean)
    }).end();
  });
}

exports.default = babelConfig;
