'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

require('./packages/shared/build/esm/node_modules/.pnpm/chalk@5.2.0/node_modules/chalk/source/index.js');
require('readline');
require('./packages/shared/build/esm/loading.js');
require('./packages/shared/build/esm/node_modules/.pnpm/semver@7.5.1/node_modules/semver/index.js');
var require$$1 = require('path');
require('./packages/shared/build/esm/node_modules/.pnpm/fs-extra@11.1.1/node_modules/fs-extra/lib/index.js');
require('node:fs');
require('node:fs/promises');
require('node:path');
require('node:url');
require('./packages/shared/build/esm/node_modules/.pnpm/parse-json@7.0.0_typescript@5.0.4/node_modules/parse-json/index.js');
require('./packages/shared/build/esm/node_modules/.pnpm/normalize-package-data@5.0.0/node_modules/normalize-package-data/lib/normalize.js');
require('child_process');
var dataTypeJudgment = require('./packages/shared/build/esm/data-type-judgment.js');
require('./packages/shared/build/esm/node_modules/.pnpm/esbuild@0.17.18/node_modules/esbuild/lib/main.js');
require('module');
var webpack = require('webpack');
var WebpackBarPlugin = require('webpackbar');

function baseConfig(api) {
  api.injectWebpackConfig((config) => {
    config.bail(false).context(api.cwd).end();
    config.mode(api.mode === "development" ? "development" : "production").end();
    config.entry("app").add(api.adcConfig.entry || "src/index.ts").end();
    config.output.path(api.resolve(api.adcConfig.outputDir || "dist")).publicPath(api.adcConfig.publicPath || "/").filename("js/[name].[contenthash:8].js").chunkFilename("js/[name].[contenthash:8].js").hashFunction("xxhash64").end();
    config.resolve.modules.add("node_modules").add(api.resolve("node_modules")).add(require$$1.resolve(__dirname, "../../node_modules")).end();
    config.resolve.extensions.merge([".js", ".cjs", ".mjs", ".jsx", ".ts", ".tsx", ".json"]).end();
    config.resolve.alias.set("@", api.resolve("src")).end();
    if (dataTypeJudgment.isPureObject(api.adcConfig.alias)) {
      Object.entries(api.adcConfig.alias).forEach(([k, v]) => {
        config.resolve.alias.set(k, v).end();
      });
    }
    if (api.adcConfig.externals) {
      config.externals(api.adcConfig.externals);
    }
    config.devtool(
      dataTypeJudgment.isString(api.adcConfig.sourceMap) ? api.adcConfig.sourceMap : api.mode === "production" ? "source-map" : false
    ).end();
    config.plugin("WebpackBarPlugin").use(WebpackBarPlugin, [
      {
        color: "#0075FF"
      }
    ]).end();
    config.plugin("DefinePlugin").use(webpack.DefinePlugin, [
      {
        NODE_ENV: JSON.stringify(api.mode),
        PUBLIC_PATH: JSON.stringify(api.adcConfig?.publicPath || "/")
      }
    ]);
  });
}

exports.default = baseConfig;
