'use strict';

const isString = (value) => {
  return Object.prototype.toString.call(value) === "[object String]" /* String */;
};
const isBoolean = (value) => {
  return Object.prototype.toString.call(value) === "[object Boolean]" /* Boolean */;
};
const isTrue = (value) => {
  return isBoolean(value) && value === true;
};
const isPureObject = (value) => {
  return Object.prototype.toString.call(value) === "[object Object]" /* Object */;
};

exports.isBoolean = isBoolean;
exports.isPureObject = isPureObject;
exports.isString = isString;
exports.isTrue = isTrue;
