'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var keyword = require('../../../../../../../_virtual/keyword.js');

Object.defineProperty(keyword.__exports, "__esModule", {
  value: true
});
keyword.__exports.isKeyword = isKeyword;
keyword.__exports.isReservedWord = isReservedWord;
keyword.__exports.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
keyword.__exports.isStrictBindReservedWord = isStrictBindReservedWord;
keyword.__exports.isStrictReservedWord = isStrictReservedWord;
const reservedWords = {
  keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
  strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
  strictBind: ["eval", "arguments"]
};
const keywords = new Set(reservedWords.keyword);
const reservedWordsStrictSet = new Set(reservedWords.strict);
const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);

function isReservedWord(word, inModule) {
  return inModule && word === "await" || word === "enum";
}

function isStrictReservedWord(word, inModule) {
  return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
}

function isStrictBindOnlyReservedWord(word) {
  return reservedWordsStrictBindSet.has(word);
}

function isStrictBindReservedWord(word, inModule) {
  return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
}

function isKeyword(word) {
  return keywords.has(word);
}

exports.default = keyword.__exports;
