'use strict';

var file = require('./file.js');
var link = require('./link.js');
var symlink = require('./symlink.js');

const { createFile, createFileSync } = file.f;
const { createLink, createLinkSync } = link.l;
const { createSymlink, createSymlinkSync } = symlink.s;

var ensure = {
  // file
  createFile,
  createFileSync,
  ensureFile: createFile,
  ensureFileSync: createFileSync,
  // link
  createLink,
  createLinkSync,
  ensureLink: createLink,
  ensureLinkSync: createLinkSync,
  // symlink
  createSymlink,
  createSymlinkSync,
  ensureSymlink: createSymlink,
  ensureSymlinkSync: createSymlinkSync
};

exports.e = ensure;
