'use strict';

require('../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.js');
var require$$1 = require('path');
var gracefulFs = require('../../../../../graceful-fs@4.2.11/node_modules/graceful-fs/graceful-fs.js');
var index = require('../mkdirs/index.js');
var index$1 = require('../path-exists/index.js');
var stat = require('../util/stat.js');
var index2 = require('../../../../../../../_virtual/index2.js');

const u = index2.__exports.fromCallback;
const path = require$$1;
const fs = gracefulFs.g;
const mkdir = index.m;
const pathExists = index$1.p.pathExists;
const { areIdentical } = stat.s;

function createLink (srcpath, dstpath, callback) {
  function makeLink (srcpath, dstpath) {
    fs.link(srcpath, dstpath, err => {
      if (err) return callback(err)
      callback(null);
    });
  }

  fs.lstat(dstpath, (_, dstStat) => {
    fs.lstat(srcpath, (err, srcStat) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureLink');
        return callback(err)
      }
      if (dstStat && areIdentical(srcStat, dstStat)) return callback(null)

      const dir = path.dirname(dstpath);
      pathExists(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return makeLink(srcpath, dstpath)
        mkdir.mkdirs(dir, err => {
          if (err) return callback(err)
          makeLink(srcpath, dstpath);
        });
      });
    });
  });
}

function createLinkSync (srcpath, dstpath) {
  let dstStat;
  try {
    dstStat = fs.lstatSync(dstpath);
  } catch {}

  try {
    const srcStat = fs.lstatSync(srcpath);
    if (dstStat && areIdentical(srcStat, dstStat)) return
  } catch (err) {
    err.message = err.message.replace('lstat', 'ensureLink');
    throw err
  }

  const dir = path.dirname(dstpath);
  const dirExists = fs.existsSync(dir);
  if (dirExists) return fs.linkSync(srcpath, dstpath)
  mkdir.mkdirsSync(dir);

  return fs.linkSync(srcpath, dstpath)
}

var link = {
  createLink: u(createLink),
  createLinkSync
};

exports.l = link;
