'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var makeDir = require('../../../../../../../_virtual/make-dir.js');
require('../fs/index.js');
require('./utils.js');
var index = require('../../../../../../../_virtual/index.js');
var utils = require('../../../../../../../_virtual/utils.js');

const fs = index.__exports;
const { checkPath } = utils.__exports;

const getMode = options => {
  const defaults = { mode: 0o777 };
  if (typeof options === 'number') return options
  return ({ ...defaults, ...options }).mode
};

makeDir.__exports.makeDir = async (dir, options) => {
  checkPath(dir);

  return fs.mkdir(dir, {
    mode: getMode(options),
    recursive: true
  })
};

makeDir.__exports.makeDirSync = (dir, options) => {
  checkPath(dir);

  return fs.mkdirSync(dir, {
    mode: getMode(options),
    recursive: true
  })
};

exports.default = makeDir.__exports;
