'use strict';

require('../../../../../r2.cnpmjs.org_universalify@2.0.0/node_modules/universalify/index.js');
var gracefulFs = require('../../../../../graceful-fs@4.2.11/node_modules/graceful-fs/graceful-fs.js');
var require$$1 = require('path');
var index = require('../mkdirs/index.js');
var index$1 = require('../path-exists/index.js');
var index2 = require('../../../../../../../_virtual/index2.js');

const u = index2.__exports.fromCallback;
const fs = gracefulFs.g;
const path = require$$1;
const mkdir = index.m;
const pathExists = index$1.p.pathExists;

function outputFile (file, data, encoding, callback) {
  if (typeof encoding === 'function') {
    callback = encoding;
    encoding = 'utf8';
  }

  const dir = path.dirname(file);
  pathExists(dir, (err, itDoes) => {
    if (err) return callback(err)
    if (itDoes) return fs.writeFile(file, data, encoding, callback)

    mkdir.mkdirs(dir, err => {
      if (err) return callback(err)

      fs.writeFile(file, data, encoding, callback);
    });
  });
}

function outputFileSync (file, ...args) {
  const dir = path.dirname(file);
  if (fs.existsSync(dir)) {
    return fs.writeFileSync(file, ...args)
  }
  mkdir.mkdirsSync(dir);
  fs.writeFileSync(file, ...args);
}

var outputFile_1 = {
  outputFile: u(outputFile),
  outputFileSync
};

exports.o = outputFile_1;
