'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var process = require('node:process');
var index = require('../../../r2.cnpmjs.org_restore-cursor@4.0.0/node_modules/restore-cursor/index.js');

let isHidden = false;

const cliCursor = {};

cliCursor.show = (writableStream = process.stderr) => {
	if (!writableStream.isTTY) {
		return;
	}

	isHidden = false;
	writableStream.write('\u001B[?25h');
};

cliCursor.hide = (writableStream = process.stderr) => {
	if (!writableStream.isTTY) {
		return;
	}

	index.default();
	isHidden = true;
	writableStream.write('\u001B[?25l');
};

cliCursor.toggle = (force, writableStream) => {
	if (force !== undefined) {
		isHidden = force;
	}

	if (isHidden) {
		cliCursor.show(writableStream);
	} else {
		cliCursor.hide(writableStream);
	}
};

exports.default = cliCursor;
