'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _commonjsHelpers = require('../../../../../_virtual/_commonjsHelpers.js');
var index7 = require('../../../../../_virtual/index7.js');
var index = require('../../../r2.cnpmjs.org_mimic-fn@2.1.0/node_modules/mimic-fn/index.js');

const mimicFn = index.m;

const calledFunctions = new WeakMap();

const onetime = (function_, options = {}) => {
	if (typeof function_ !== 'function') {
		throw new TypeError('Expected a function');
	}

	let returnValue;
	let callCount = 0;
	const functionName = function_.displayName || function_.name || '<anonymous>';

	const onetime = function (...arguments_) {
		calledFunctions.set(onetime, ++callCount);

		if (callCount === 1) {
			returnValue = function_.apply(this, arguments_);
			function_ = null;
		} else if (options.throw === true) {
			throw new Error(`Function \`${functionName}\` can only be called once`);
		}

		return returnValue;
	};

	mimicFn(onetime, function_);
	calledFunctions.set(onetime, callCount);

	return onetime;
};

index7.__module.exports = onetime;
// TODO: Remove this for the next major release
index7.__module.exports.default = onetime;

index7.__module.exports.callCount = function_ => {
	if (!calledFunctions.has(function_)) {
		throw new Error(`The given function \`${function_.name}\` is not wrapped by the \`onetime\` package`);
	}

	return calledFunctions.get(function_);
};

var onetimeExports = index7.__module.exports;
var onetime$1 = /*@__PURE__*/_commonjsHelpers.getDefaultExportFromCjs(onetimeExports);

exports.default = onetime$1;
