'use strict';

var eq$1 = require('./eq.js');
var neq$1 = require('./neq.js');
var gt$1 = require('./gt.js');
var gte$1 = require('./gte.js');
var lt$1 = require('./lt.js');
var lte$1 = require('./lte.js');

const eq = eq$1.e;
const neq = neq$1.n;
const gt = gt$1.g;
const gte = gte$1.g;
const lt = lt$1.l;
const lte = lte$1.l;

const cmp = (a, op, b, loose) => {
  switch (op) {
    case '===':
      if (typeof a === 'object') {
        a = a.version;
      }
      if (typeof b === 'object') {
        b = b.version;
      }
      return a === b

    case '!==':
      if (typeof a === 'object') {
        a = a.version;
      }
      if (typeof b === 'object') {
        b = b.version;
      }
      return a !== b

    case '':
    case '=':
    case '==':
      return eq(a, b, loose)

    case '!=':
      return neq(a, b, loose)

    case '>':
      return gt(a, b, loose)

    case '>=':
      return gte(a, b, loose)

    case '<':
      return lt(a, b, loose)

    case '<=':
      return lte(a, b, loose)

    default:
      throw new TypeError(`Invalid operator: ${op}`)
  }
};
var cmp_1 = cmp;

exports.c = cmp_1;
