'use strict';

var re = require('./internal/re.js');
var constants$1 = require('./internal/constants.js');
var semver = require('./classes/semver.js');
var identifiers$1 = require('./internal/identifiers.js');
var parse$1 = require('./functions/parse.js');
var valid$1 = require('./functions/valid.js');
var clean$1 = require('./functions/clean.js');
var inc$1 = require('./functions/inc.js');
var diff$1 = require('./functions/diff.js');
var major$1 = require('./functions/major.js');
var minor$1 = require('./functions/minor.js');
var patch$1 = require('./functions/patch.js');
var prerelease$1 = require('./functions/prerelease.js');
var compare$1 = require('./functions/compare.js');
var rcompare$1 = require('./functions/rcompare.js');
var compareLoose$1 = require('./functions/compare-loose.js');
var compareBuild$1 = require('./functions/compare-build.js');
var sort$1 = require('./functions/sort.js');
var rsort$1 = require('./functions/rsort.js');
var gt$1 = require('./functions/gt.js');
var lt$1 = require('./functions/lt.js');
var eq$1 = require('./functions/eq.js');
var neq$1 = require('./functions/neq.js');
var gte$1 = require('./functions/gte.js');
var lte$1 = require('./functions/lte.js');
var cmp$1 = require('./functions/cmp.js');
var coerce$1 = require('./functions/coerce.js');
var comparator = require('./classes/comparator.js');
var range = require('./classes/range.js');
var satisfies$1 = require('./functions/satisfies.js');
var toComparators$1 = require('./ranges/to-comparators.js');
var maxSatisfying$1 = require('./ranges/max-satisfying.js');
var minSatisfying$1 = require('./ranges/min-satisfying.js');
var minVersion$1 = require('./ranges/min-version.js');
var valid$2 = require('./ranges/valid.js');
var outside$1 = require('./ranges/outside.js');
var gtr$1 = require('./ranges/gtr.js');
var ltr$1 = require('./ranges/ltr.js');
var intersects$1 = require('./ranges/intersects.js');
var simplify = require('./ranges/simplify.js');
var subset$1 = require('./ranges/subset.js');

// just pre-load all the stuff that index.js lazily exports
const internalRe = re.r;
const constants = constants$1.c;
const SemVer = semver.s;
const identifiers = identifiers$1.i;
const parse = parse$1.p;
const valid = valid$1.v;
const clean = clean$1.c;
const inc = inc$1.i;
const diff = diff$1.d;
const major = major$1.m;
const minor = minor$1.m;
const patch = patch$1.p;
const prerelease = prerelease$1.p;
const compare = compare$1.c;
const rcompare = rcompare$1.r;
const compareLoose = compareLoose$1.c;
const compareBuild = compareBuild$1.c;
const sort = sort$1.s;
const rsort = rsort$1.r;
const gt = gt$1.g;
const lt = lt$1.l;
const eq = eq$1.e;
const neq = neq$1.n;
const gte = gte$1.g;
const lte = lte$1.l;
const cmp = cmp$1.c;
const coerce = coerce$1.c;
const Comparator = comparator.__require();
const Range = range.__require();
const satisfies = satisfies$1.s;
const toComparators = toComparators$1.t;
const maxSatisfying = maxSatisfying$1.m;
const minSatisfying = minSatisfying$1.m;
const minVersion = minVersion$1.m;
const validRange = valid$2.v;
const outside = outside$1.o;
const gtr = gtr$1.g;
const ltr = ltr$1.l;
const intersects = intersects$1.i;
const simplifyRange = simplify.s;
const subset = subset$1.s;
({
  parse,
  valid,
  clean,
  inc,
  diff,
  major,
  minor,
  patch,
  prerelease,
  compare,
  rcompare,
  compareLoose,
  compareBuild,
  sort,
  rsort,
  gt,
  lt,
  eq,
  neq,
  gte,
  lte,
  cmp,
  coerce,
  Comparator,
  Range,
  satisfies,
  toComparators,
  maxSatisfying,
  minSatisfying,
  minVersion,
  validRange,
  outside,
  gtr,
  ltr,
  intersects,
  simplifyRange,
  subset,
  SemVer,
  re: internalRe.re,
  src: internalRe.src,
  tokens: internalRe.t,
  SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
  RELEASE_TYPES: constants.RELEASE_TYPES,
  compareIdentifiers: identifiers.compareIdentifiers,
  rcompareIdentifiers: identifiers.rcompareIdentifiers,
});
